﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
	<title></title>
	<style type="text/css">
		.toBeCopied {
			background: #bde0c5!important;
		}

		.toPasteFrom {
			background: #e0f6ff!important;
		}
	</style>
</head>
<body>
	<form id="form1" runat="server">
		<asp:ScriptManager ID="RadScriptManager1" runat="server">
			<Scripts>
				<asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.Core.js" />
				<asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQuery.js" />
				<asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQueryInclude.js" />
			</Scripts>
		</asp:ScriptManager>

		<telerik:RadCodeBlock ID="RadCodeBlock1" runat="server">
		    <script type="text/javascript">
		    	var demo = (function () {
		    		var copiedCell = null;
		    		var copiedCellValue;
		    		var copiedDataItem = null;
		    		var currentTargetCell;
		    		var currentTargetCellValue;
		    		var currentTargetDataItem;
		    		var batchManager;
		    		var applyHoverStyles;

		    		window.pageLoad = function () {
		    			batchManager = $find("<%=RadGrid1.ClientID%>").get_batchEditingManager();
		            }

					// creates a string representation of the copied row, which will be displayed as a tooltip for the "Paste Row" item
		        	function createRowItemToolTip(row) {
		        		var content = [];
		        		for (var i = 0; i < row.cells.length; i++) {
		        			content.push(batchManager.getCellValue(row.cells[i]));
		        		}

		        		return content.join(", ");
		        	}

					// clears all custom styles added to cells/rows
		        	function clearStyles() {
		        		if (copiedCell != null) {
		        			copiedCell.className = copiedCell.className.replace("toPasteFrom", "");
		        		}

		        		if (copiedDataItem != null) {
		        			copiedDataItem.get_element().className = copiedDataItem.get_element().className.replace("toPasteFrom", "");
		        		}

		        		currentTargetDataItem.get_element().className = currentTargetDataItem.get_element().className.replace("toBeCopied", "");
		        		currentTargetCell.className = currentTargetCell.className.replace("toBeCopied", "");
		        	}

		        	return {
		        		rowContextMenu: function (sender, args) {
		        			applyHoverStyles = true;
		        			var contextMenu = $find("<%=RadContextMenu1.ClientID%>");
			            	contextMenu.show(args.get_domEvent());
			            	currentTargetCell = Telerik.Web.UI.Grid.GetFirstParentByTagName(args.get_domEvent().target, "TD");
			            	currentTargetCellValue = batchManager.getCellValue(currentTargetCell);
			            	currentTargetDataItem = args.get_gridDataItem();
			            },

		        		itemClicked: function (sender, args) {
		        			applyHoverStyles = false;
			            	var clickedValue = args.get_item().get_value();
			            	if (clickedValue == "CopyCell") {
			            		copiedCell = currentTargetCell;
			            		copiedCellValue = currentTargetCellValue;
			            		sender.get_items().getItem(1).set_enabled(true);
			            		sender.get_items().getItem(1).get_element().setAttribute("title", copiedCellValue);
			            	} else if (clickedValue == "PasteCell") {
			            		batchManager.changeCellValue(currentTargetCell, copiedCellValue);
			            	} else if (clickedValue == "CopyRow") {
			            		copiedDataItem = currentTargetDataItem;
			            		sender.get_items().getItem(3).set_enabled(true);
			            		sender.get_items().getItem(3).get_element().setAttribute("title", createRowItemToolTip(copiedDataItem.get_element()));
			            	} else {
			            		var copiedRow = copiedDataItem.get_element();
			            		var currentRow = currentTargetDataItem.get_element();
			            		for (var i = 0; i < copiedRow.cells.length; i++) {
			            			batchManager.changeCellValue(currentRow.cells[i], batchManager.getCellValue(copiedRow.cells[i]));
			            		}
			            	}
			            	
			            	clearStyles();
			            },

						//used for changing the style for the target cell
		        		mouseOver: function (sender, args) {
		        			if (applyHoverStyles) {
		        				var hoverValue = args.get_item().get_value();
		        				if (hoverValue == "CopyCell") {
		        					currentTargetCell.className += " toBeCopied";
		        				} else if (hoverValue == "PasteCell") {
		        					currentTargetCell.className += " toBeCopied";
		        					copiedCell.className += " toPasteFrom";
		        				} else if (hoverValue == "CopyRow") {
		        					currentTargetDataItem.get_element().className += " toBeCopied";
		        				} else if (hoverValue == "PasteRow") {
		        					copiedDataItem.get_element().className += " toPasteFrom";
		        					currentTargetDataItem.get_element().className += " toBeCopied";
		        				}
		        			}
			            },

			            mouseOut: function (sender, args) {
			            	clearStyles();
			            },

			            hidden: function () {
			            	clearStyles();
			            }
			        }
		        })();
		    </script>
		</telerik:RadCodeBlock>
		
		<telerik:RadContextMenu runat="server" ID="RadContextMenu1" OnClientMouseOver="demo.mouseOver" OnClientHidden="demo.hidden"
			 OnClientMouseOut="demo.mouseOut" OnClientItemClicked="demo.itemClicked">
			<Items>
				<telerik:RadMenuItem Text="Copy cell" Value="CopyCell"></telerik:RadMenuItem>
				<telerik:RadMenuItem Text="Paste cell" Value="PasteCell" Enabled="false"></telerik:RadMenuItem>
				<telerik:RadMenuItem Text="Copy row" Value="CopyRow"></telerik:RadMenuItem>
				<telerik:RadMenuItem Text="Paste row" Value="PasteRow" Enabled="false"></telerik:RadMenuItem>
			</Items>
		</telerik:RadContextMenu>

		<telerik:RadGrid runat="server" ID="RadGrid1" OnNeedDataSource="RadGrid1_NeedDataSource" Width="500px">
			<MasterTableView EditMode="Batch" CommandItemDisplay="Top">
				<BatchEditingSettings EditType="Row" />
			</MasterTableView>
			<ClientSettings>
				<ClientEvents OnRowContextMenu="demo.rowContextMenu" />
			</ClientSettings>
		</telerik:RadGrid>
	</form>
</body>
</html>
